@ECHO OFF
rem Nnecessary ext. tools (lib.exe mspdb100.dll msvcr100.dll)
SET ORGPATH=%PATH%

:X32
FOR /F "usebackq" %%t IN (`83 "%ProgramFiles%\BestTech\GCC Developer Lite\GCC\"`) DO SET GCCBIN=%%t
GOTO INPUT

:X64
FOR /F "usebackq" %%t IN (`83 "%ProgramFiles(x86)%\BestTech\GCC Developer Lite\GCC\"`) DO SET GCCBIN=%%t
GOTO INPUT

:INPUT

if not exist %GCCBIN% goto err

echo #### 32bit ####
SET PATH=%GCCBIN%x86\bin;%ORGPATH%
gcc -Wall -shared -o krslib_x32.dll krslib.c -O3 -static-libgcc -Wall -Wno-main -Wnested-externs -Wshadow -Wcast-align -Wimplicit -Wpointer-arith -Wswitch -Wredundant-decls -Wreturn-type -Wshadow -Wunused -Wl,--add-stdcall-alias,--output-def,krslib_x32.def,--out-implib,libkrslib_x32.a
if not exist lib.exe goto err
lib /DEF:krslib_x32.def /MACHINE:X86 /out:krslib_x32.lib

echo #### 64bit ####
SET PATH=%GCCBIN%x64\bin;%ORGPATH%
gcc -Wall -shared -o krslib_x64.dll krslib.c -O3 -static-libgcc -Wall -Wno-main -Wnested-externs -Wshadow -Wcast-align -Wimplicit -Wpointer-arith -Wswitch -Wredundant-decls -Wreturn-type -Wshadow -Wunused -Wl,--add-stdcall-alias,--output-def,krslib_x64.def,--out-implib,libkrslib_x64.a
if not exist lib.exe goto err
lib /DEF:krslib_x64.def /MACHINE:X64 /out:krslib_x64.lib
goto ok

rem #### linuxt ####
rem gcc -c -O3 krslib.c -o krslib.o -lpthread -lrt
rem gcc -fPIC -shared -O3 krslib.c -o krslib.so -lpthread -lrt

:err
echo ---------------------------
echo !! create lib error !!
echo ---------------------------
goto fin

:ok
echo ---------------------------
echo !! create lib success !!
echo ---------------------------
goto fin

:fin
copy krslib*.dll .\SampleCode.
copy *.h .\SampleCode.
pause
SET PATH=%ORGPATH%
